source: common/common-functions@ 05d1b17

2.3 2.3.x 2.4 ablfs ablfs-more legacy new_features trunk
Last change on this file since 05d1b17 was 05d1b17, checked in by George Boudreau <georgeb@…>, 18 years ago

I do not know why this change is needed.. it causes and error exit otherwise

  • Property mode set to 100644
File size: 24.6 KB
RevLine 
[877cc6a]1#!/bin/bash
2
3# $Id$
4
[4da2512]5set -e
[877cc6a]6
7
8no_empty_builddir() {
9 'clear'
10cat <<- -EOF-
11${DD_BORDER}
12
13${tab_}${tab_}${BOLD}${RED}W A R N I N G${OFF}
14 Looks like the \$BUILDDIR directory contains subdirectories
15 from a previous HLFS build.
16
17 Please format the partition mounted on \$BUILDDIR or set
[73e5448]18 a different build directory before running jhalfs.
[877cc6a]19${OFF}
20${DD_BORDER}
21-EOF-
22 exit
23}
24
25
[73e5448]26HEADER="# This file is automatically generated by jhalfs
[877cc6a]27# DO NOT EDIT THIS FILE MANUALLY
28#
29# Generated on `date \"+%F %X %Z\"`"
30
31
32
33#----------------------------------#
[3a321ea]34wrt_target() { # Create target and initialize log file
[877cc6a]35#----------------------------------#
36 local i=$1
37 local PREV=$2
[4edf3b7]38 case $i in
39 iteration* ) local LOGFILE=$this_script.log ;;
40 * ) local LOGFILE=$this_script ;;
41 esac
[877cc6a]42(
43cat << EOF
44
45$i: $PREV
46 @\$(call echo_message, Building)
[46758a2]47 @./progress_bar.sh \$@ &
[1a1f099]48 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >logs/$LOGFILE
[877cc6a]49EOF
50) >> $MKFILE.tmp
51}
52
[7eb9402]53
54#----------------------------------#
55wrt_target_boot() { # Create target and initialize log file
56#----------------------------------#
57 local i=$1
58 local PREV=$2
59 case $i in
60 iteration* ) local LOGFILE=$this_script.log ;;
61 * ) local LOGFILE=$this_script ;;
62 esac
63(
64cat << EOF
65
66$i: $PREV
67 @\$(call echo_message, Building)
68 @./progress_bar.sh \$@ &
69 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT}\`\n" >logs/$LOGFILE
70EOF
71) >> $MKFILE.tmp
72}
73
[dd29d02]74#----------------------------#
75get_package_tarball_name() { #
76#----------------------------#
77 local script_name=$1
78
79 # The use of 'head' is necessary to limit the return value to the FIRST match..
80 # hopefully this will not cause problems.
81 #
82 case $script_name in
[6ad5a2f]83 tcl) echo $(grep "^tcl" $JHALFSDIR/pkg_tarball_list | head -n1 ) ;;
[983db9f]84 linux-headers) echo $(grep "^linux-headers.*.bz2" $JHALFSDIR/pkg_tarball_list | head -n1 ) ;;
[6ad5a2f]85 *) echo $(grep "^$script_name-[[:digit:]]" $JHALFSDIR/pkg_tarball_list | head -n1 ) ;;
[dd29d02]86 esac
87
88}
[877cc6a]89
[401f81e]90
[5842156]91#----------------------------------#
[401f81e]92wrt_test_log() { # Initialize testsuite log file
[5842156]93#----------------------------------#
[401f81e]94 local TESTLOGFILE=$1
[5842156]95(
[401f81e]96cat << EOF
97 @echo "export TEST_LOG=$TESTLOGDIR/$TESTLOGFILE" >> envars && \\
98 su - \$(LUSER) -c "echo -e '\n\`date\`\n' >$TESTLOGDIR/$TESTLOGFILE"
[5842156]99EOF
100) >> $MKFILE.tmp
101}
102
103#----------------------------------#
[401f81e]104wrt_test_log2() { #
[5842156]105#----------------------------------#
[401f81e]106 local TESTLOGFILE=$1
[5842156]107(
[401f81e]108cat << EOF
109 @echo "export TEST_LOG=/$SCRIPT_ROOT/test-logs/$TESTLOGFILE" >> envars && \\
110 echo -e "\n\`date\`\n" >test-logs/$TESTLOGFILE
111EOF
112) >> $MKFILE.tmp
113}
114
115#----------------------------------#
116wrt_target_vars() { # Target vars for hlfs (cross-build method)
117#----------------------------------#
118(
119cat << EOF
120 @echo "export target=$(uname -m)-${TARGET}" >> envars && \\
121 echo "export ldso=/lib/${LOADER}" >> envars
122EOF
123) >> $MKFILE.tmp
124
125}
126
127
128#----------------------------------#
129wrt_copy_fstab() { #
130#----------------------------------#
131 local i=$1
132(
133 cat << EOF
134 @cp -v $FSTAB \$(MOUNT_PT)/etc/fstab >>logs/$i 2>&1
135EOF
136) >> $MKFILE.tmp
137}
138
139
140#----------------------------------#
141wrt_copy_fstab2() { #
142#----------------------------------#
143 local i=$1
144(
145 cat << EOF
146 @cp -v /sources/fstab /etc/fstab >>logs/$i 2>&1
[5842156]147EOF
148) >> $MKFILE.tmp
149}
150
151
[401f81e]152#----------------------------------#
153wrt_report() { #
154#----------------------------------#
155(
156cat << EOF
[5842156]157
[401f81e]158create-sbu_du-report: $PREV
159 @\$(call echo_message, Building)
160 @./create-sbu_du-report.sh logs $VERSION
161 @\$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report)
162 @touch \$@
163EOF
164) >> $MKFILE.tmp
165
166chapter789="$chapter789 create-sbu_du-report"
167}
168
169unset wrt_unpack
[877cc6a]170#----------------------------------#
171wrt_unpack() { # Unpack and set 'ROOT' var
172#----------------------------------#
173 local FILE=$1
[5842156]174 local optSAVE_PREVIOUS=$2
[82eb8c1]175
[401f81e]176 if [[ "${optSAVE_PREVIOUS}" != "1" ]]; then
177(
178cat << EOF
179 @\$(call remove_existing_dirs,$FILE)
180EOF
181) >> $MKFILE.tmp
[5842156]182 fi
[401f81e]183
[877cc6a]184(
185cat << EOF
186 @\$(call unpack,$FILE)
[401f81e]187 @\$(call get_pkg_root)
[e5f5970]188EOF
189) >> $MKFILE.tmp
190
[401f81e]191}
[e5f5970]192
[401f81e]193unset wrt_unpack2
[877cc6a]194#----------------------------------#
195wrt_unpack2() { #
196#----------------------------------#
197 local FILE=$1
[5842156]198 local optSAVE_PREVIOUS=$2
199
200 if [ "${optSAVE_PREVIOUS}" != "1" ]; then
[401f81e]201(
202cat << EOF
203 @\$(call remove_existing_dirs,$FILE)
204EOF
205) >> $MKFILE.tmp
[5842156]206 fi
[877cc6a]207(
208cat << EOF
209 @\$(call unpack2,$FILE)
[401f81e]210 @\$(call get_pkg_root,nouser)
[877cc6a]211EOF
212) >> $MKFILE.tmp
213}
214
[261eea6]215#----------------------------------#
216wrt_unpack3() { #
217#----------------------------------#
[877cc6a]218 local FILE=$1
[5842156]219 local optSAVE_PREVIOUS=$2
220
221 if [ "${optSAVE_PREVIOUS}" != "1" ]; then
[401f81e]222(
223cat << EOF
224 @\$(call remove_existing_dirs2,$FILE)
225EOF
226) >> $MKFILE.tmp
[5842156]227 fi
[877cc6a]228(
229cat << EOF
230 @\$(call unpack3,$FILE)
[401f81e]231 @\$(call get_pkg_root2)
[877cc6a]232EOF
233) >> $MKFILE.tmp
234}
235
[401f81e]236
237unset wrt_remove_build_dirs
[a229600]238#----------------------------------#
[401f81e]239wrt_remove_build_dirs() { #
[a229600]240#----------------------------------#
[401f81e]241 local name=$1
[a229600]242(
[401f81e]243cat << EOF
244 @\$(call remove_build_dirs,$name)
[a229600]245EOF
246) >> $MKFILE.tmp
247}
248
249#----------------------------------#
[401f81e]250wrt_remove_build_dirs2() { #
[a229600]251#----------------------------------#
[401f81e]252 local name=$1
[a229600]253(
[401f81e]254cat << EOF
255 @\$(call remove_build_dirs2,$name)
[a229600]256EOF
257) >> $MKFILE.tmp
258}
259
[401f81e]260
261
262unset wrt_touch
[877cc6a]263#----------------------------------#
[401f81e]264wrt_touch() { #
[877cc6a]265#----------------------------------#
266(
[401f81e]267cat << EOF
268 @\$(call housekeeping)
[877cc6a]269EOF
270) >> $MKFILE.tmp
271}
272
[401f81e]273unset wrt_RunAsUser
[877cc6a]274#----------------------------------#
[6ad5a2f]275wrt_RunAsUser() { # Execute script inside time { }, footer to log file
[877cc6a]276#----------------------------------#
277 local this_script=$1
278 local file=$2
[401f81e]279
[877cc6a]280(
281cat << EOF
[401f81e]282 @( time { \$(SU_LUSER) "source \$(LUSER_HOME)/.bashrc && \$(CMDSDIR)/`dirname $file`/\$@" >> logs/\$@ 2>&1; } ) 2>> logs/\$@ && \\
283 \$(PRT_DU) >> logs/\$@
[877cc6a]284EOF
285) >> $MKFILE.tmp
286}
287
288
[e5f5970]289#----------------------------------#
[6ad5a2f]290wrt_RunAsRoot() { # Some scripts must be run as root..
[e5f5970]291#----------------------------------#
[6ad5a2f]292 local ENV_MOUNT
[e5f5970]293 local this_script=$1
294 local file=$2
295
[6ad5a2f]296 case ${PROGNAME} in
297 lfs ) MOUNT_ENV="LFS" ;;
298 blfs ) MOUNT_ENV="BLFS" ;;
299 clfs ) MOUNT_ENV="CLFS" ;;
300 clfs2 ) MOUNT_ENV="CLFS" ;;
301 hlfs ) MOUNT_ENV="HLFS" ;;
302 *) echo "undefined progname $PROGNAME"; exit 1
303 esac
[e5f5970]304
[ac1d897]305(
306cat << EOF
[401f81e]307 @( time { export ${MOUNT_ENV}=\$(MOUNT_PT) && ${PROGNAME}-commands/`dirname $file`/\$@ >>logs/\$@ 2>&1 ; } ) 2>>logs/\$@ && \\
308 \$(PRT_DU_CR) >>logs/\$@
[ac1d897]309EOF
310) >> $MKFILE.tmp
311}
312
[261eea6]313#----------------------------------#
314wrt_run_as_root2() { #
315#----------------------------------#
[877cc6a]316 local this_script=$1
317 local file=$2
318(
319cat << EOF
[401f81e]320 @( time { source envars && ${PROGNAME}-commands/`dirname $file`/\$@ >>logs/\$@ 2>&1 ; } ) 2>>logs/\$@ && \\
321 echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \`\n" >>logs/\$@
[877cc6a]322EOF
323) >> $MKFILE.tmp
324}
325
326
[401f81e]327unset wrt_run_as_chroot1
[877cc6a]328#----------------------------------#
329wrt_run_as_chroot1() { #
330#----------------------------------#
331 local this_script=$1
332 local file=$2
333(
[401f81e]334cat << EOF
[3619bc5]335 @( time { \$(CHROOT1) 'cd \$(SCRIPT_ROOT) && source envars && \$(crCMDSDIR)/$file >>logs/${this_script} 2>&1' ; } ) 2>>logs/${this_script} && \\
336 \$(PRT_DU_CR) >> logs/${this_script}
[877cc6a]337EOF
338) >> $MKFILE.tmp
339}
340
[401f81e]341unset wrt_run_as_chroot2
[877cc6a]342#----------------------------------#
343wrt_run_as_chroot2() { #
344#----------------------------------#
345 local this_script=$1
346 local file=$2
347(
348cat << EOF
[4275c72]349 @( time { \$(CHROOT2) 'cd \$(SCRIPT_ROOT) && source envars && \$(crCMDSDIR)/`dirname $file`/\$@ >>logs/\$@ 2>&1' ; } ) 2>>logs/\$@ && \\
[401f81e]350 \$(PRT_DU_CR) >> logs/\$@
[877cc6a]351EOF
352) >> $MKFILE.tmp
353}
354
[401f81e]355unset wrt_target
[877cc6a]356#----------------------------------#
[401f81e]357wrt_target() { # Create target and initialize log file
[877cc6a]358#----------------------------------#
359 local i=$1
[401f81e]360 local PREV=$2
361 case $i in
362 iteration* ) local LOGFILE="\$@.log" ;;
363 * ) local LOGFILE="\$@" ;;
364 esac
[0bdf6ed]365(
366cat << EOF
[877cc6a]367
[401f81e]368$i: $PREV
369 @\$(call echo_message, Building)
370 @./progress_bar.sh \$@ &
371 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >logs/$LOGFILE
[e2ef100]372EOF
373) >> $MKFILE.tmp
374}
375
[453bef0]376#----------------------------------#
[401f81e]377wrt_target_boot() { # Create target and initialize log file
[453bef0]378#----------------------------------#
[401f81e]379 local i=$1
380 local PREV=$2
381 case $i in
382 iteration* ) local LOGFILE="\$@.log" ;;
383 * ) local LOGFILE="\$@" ;;
384 esac
[453bef0]385(
386cat << EOF
387
[401f81e]388$i: $PREV
[453bef0]389 @\$(call echo_message, Building)
[401f81e]390 @./progress_bar.sh \$@ &
391 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT}\`\n" >logs/$LOGFILE
[453bef0]392EOF
393) >> $MKFILE.tmp
394}
395
396
[401f81e]397
[877cc6a]398#----------------------------#
[261eea6]399run_make() { #
[877cc6a]400#----------------------------#
401 # Test if make must be run.
[401f81e]402 if [ "$RUNMAKE" = "y" ] ; then
[877cc6a]403 # Test to make sure we're running the build as root
404 if [ "$UID" != "0" ] ; then
405 echo "You must be logged in as root to successfully build the system."
406 exit 1
407 fi
408 # Build the system
409 if [ -e $MKFILE ] ; then
410 echo -ne "Building the system...\n"
[a167246]411 cd $JHALFSDIR && make
[877cc6a]412 echo -ne "done\n"
413 fi
414 fi
415}
416
417
418#----------------------------#
[261eea6]419clean_builddir() { #
[877cc6a]420#----------------------------#
421 # Test if the clean must be done.
[401f81e]422 if [ "${CLEAN}" = "y" ]; then
[877cc6a]423 # Test to make sure we're running the clean as root
424 if [ "$UID" != "0" ] ; then
425 echo "You must be logged in as root to clean the build directory."
426 exit 1
427 fi
428 # Test to make sure that the build directory was populated by jhalfs
429 if [ ! -d $JHALFSDIR ] || [ ! -d $BUILDDIR/sources ] ; then
[73e5448]430 echo "Looks like $BUILDDIR was not populated by a previous jhalfs run."
[877cc6a]431 exit 1
432 else
433 # Clean the build directory
434 echo -ne "Cleaning $BUILDDIR...\n"
435 rm -rf $BUILDDIR/{bin,boot,dev,etc,home,lib,media,mnt,opt,proc,root,sbin,srv,sys,tmp,tools,cross-tools,usr,var}
436 echo -ne "Cleaning $JHALFSDIR...\n"
[dd29d02]437 rm -rf $JHALFSDIR/{0*,1*,envars,sources-dir,*commands,*logs,Makefile,*.xsl,makefile-functions,pkg_tarball_list,*.config,*.sh}
[877cc6a]438 echo -ne "Cleaning remainig extracted sources in $BUILDDIR/sources...\n"
439 rm -rf `find $BUILDDIR/sources/* -maxdepth 0 -type d`
440 echo -ne "done\n"
441 fi
442 fi
443}
444
445#----------------------------#
[261eea6]446get_book() { #
[877cc6a]447#----------------------------#
448 cd $JHALFSDIR
449
[4da2512]450 if [ -z $WORKING_COPY ] ; then
[877cc6a]451 # Check for Subversion instead of just letting the script hit 'svn' and fail.
452 test `type -p svn` || eval "echo \"This feature requires Subversion.\"
453 exit 1"
454 echo -n "Downloading the $PROGNAME document, $LFSVRS version... "
455
456 case $PROGNAME in
457 lfs) svn_root="LFS" ;;
458 hlfs) svn_root="HLFS" ;;
459 clfs) svn_root="cross-lfs" ;;
[7432834]460 clfs2) svn_root="cross-lfs" ;;
[877cc6a]461 *) echo "BOOK not defined in function <get_book>"
462 exit 1 ;;
463 esac
464 # Grab a fresh book if it's missing, otherwise, update it from the
465 # repo. If we've already extracted the commands, move on to getting the
466 # sources.
467 if [ -d ${PROGNAME}-$LFSVRS ] ; then
468 cd ${PROGNAME}-$LFSVRS
[1ff6768]469 if LC_ALL=C svn up | grep -q At && \
470 test -d $JHALFSDIR/${PROGNAME}-commands && \
471 test -f $JHALFSDIR/pkg_tarball_list ; then
[877cc6a]472 # Set the canonical book version
[a6655ff]473 echo -ne "done\n"
[877cc6a]474 cd $JHALFSDIR
[1ff6768]475 case $PROGNAME in
[7432834]476 clfs | clfs2)
[1ff6768]477 VERSION=$(xmllint --noent $BOOK/prologue/$ARCH/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
478 *)
479 VERSION=$(xmllint --noent $BOOK/prologue/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
480 esac
[877cc6a]481 get_sources
482 else
483 echo -ne "done\n"
484 extract_commands
485 fi
486 else
[cb39f79]487 svn co $SVN/${svn_root}/${TREE} ${PROGNAME}-$LFSVRS >>$LOGDIR/$LOG 2>&1
[877cc6a]488 echo -ne "done\n"
489 extract_commands
490 fi
[1ff6768]491
[877cc6a]492 else
493 echo -ne "Using $BOOK as book's sources ...\n"
494 extract_commands
495 fi
[a6655ff]496 echo -ne " Document version ${L_arrow}${BOLD}${VERSION}${R_arrow}\n"
[877cc6a]497}
498
499#----------------------------#
500extract_commands() { #
501#----------------------------#
502
503 # Check for libxslt instead of just letting the script hit 'xsltproc' and fail.
504 test `type -p xsltproc` || eval "echo \"This feature requires libxslt.\"
505 exit 1"
506
507 cd $JHALFSDIR
[1ff6768]508 case $PROGNAME in
[7432834]509 clfs | clfs2 )
[1ff6768]510 VERSION=$(xmllint --noent $BOOK/prologue/$ARCH/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
511 *)
512 VERSION=$(xmllint --noent $BOOK/prologue/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
513 esac
[877cc6a]514
515 # Start clean
[bfc07d6]516 if [ -d ${PROGNAME}-commands ]; then
517 rm -rf ${PROGNAME}-commands
518 mkdir -v ${PROGNAME}-commands
[877cc6a]519 fi
520 echo -n "Extracting commands for"
521
522 # Dump the commands in shell script form from the HLFS book.
523 case ${PROGNAME} in
524 clfs)
525 echo -n " ${L_arrow}${BOLD}$ARCH${R_arrow} target architecture"
526 xsltproc --nonet \
527 --xinclude \
528 --stringparam method $METHOD \
529 --stringparam testsuite $TEST \
[28f4756]530 --stringparam bomb-testsuite $BOMB_TEST \
[877cc6a]531 --stringparam vim-lang $VIMLANG \
532 --stringparam timezone $TIMEZONE \
533 --stringparam page $PAGE \
534 --stringparam lang $LANG \
[401f81e]535 --stringparam keymap $KEYMAP \
[877cc6a]536 -o ./${PROGNAME}-commands/ $XSL $BOOK/$ARCH-index.xml >>$LOGDIR/$LOG 2>&1
537 ;;
[7432834]538
539 clfs2)
540 echo -n " ${L_arrow}${BOLD}$ARCH${R_arrow} target architecture"
541 xsltproc --nonet \
542 --xinclude \
543 --stringparam vim-lang $VIMLANG \
544 --stringparam timezone $TIMEZONE \
545 --stringparam page $PAGE \
546 --stringparam lang $LANG \
[401f81e]547 --stringparam keymap $KEYMAP \
[7432834]548 -o ./${PROGNAME}-commands/ $XSL $BOOK/$ARCH-index.xml >>$LOGDIR/$LOG 2>&1
549 ;;
[877cc6a]550 hlfs)
551 echo -n " ${L_arrow}${BOLD}$MODEL${R_arrow} HLFS libc implementation"
552 xsltproc --nonet \
553 --xinclude \
554 --stringparam model $MODEL \
555 --stringparam testsuite $TEST \
[28f4756]556 --stringparam bomb-testsuite $BOMB_TEST \
[877cc6a]557 --stringparam timezone $TIMEZONE \
558 --stringparam page $PAGE \
559 --stringparam lang $LANG \
560 --stringparam lc_all $LC_ALL \
[401f81e]561 --stringparam keymap $KEYMAP \
[877cc6a]562 --stringparam grsecurity_host $GRSECURITY_HOST \
563 -o ./${PROGNAME}-commands/ $XSL $BOOK/index.xml >>$LOGDIR/$LOG 2>&1
564 ;;
565 lfs)
566 echo -n " ${L_arrow}${BOLD}LFS${R_arrow} build"
567 xsltproc --nonet \
568 --xinclude \
569 --stringparam testsuite $TEST \
[28f4756]570 --stringparam bomb-testsuite $BOMB_TEST \
[877cc6a]571 --stringparam vim-lang $VIMLANG \
572 --stringparam timezone $TIMEZONE \
573 --stringparam page $PAGE \
574 --stringparam lang $LANG \
575 -o ./${PROGNAME}-commands/ $XSL $BOOK/index.xml >>$LOGDIR/$LOG 2>&1
576 ;;
[15cad16]577 *) exit 1 ;;
[877cc6a]578 esac
579
[4965fa8]580 [[ "${BLFS_TOOL}" = "y" ]] && copy_blfs_deps_scripts
581
[877cc6a]582 echo " ...OK"
583
584 # Make the scripts executable.
585 chmod -R +x $JHALFSDIR/${PROGNAME}-commands
586
[15cad16]587 # Create the packages file. We need it for proper Makefile creation
[dd29d02]588 create_package_list
[877cc6a]589
590 # Done. Moving on...
591 get_sources
592}
593
[dd29d02]594#----------------------------#
595create_package_list() { #
596#----------------------------#
597
598 # Create the packages file. We need it for proper Makefile creation
599 rm -f pkg_tarball_list
600 echo -n "Creating <${PROGNAME}> list of tarball names for $BOOK $ARCH"
601 case ${PROGNAME} in
[7432834]602 clfs | clfs2)
[dd29d02]603 xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
604 $BOOK/materials/${ARCH}-chapter.xml >>$LOGDIR/$LOG 2>&1
605 ;;
606 hlfs)
607 xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
608 $BOOK/chapter04/chapter04.xml >>$LOGDIR/$LOG 2>&1
609 ;;
610 lfs)
611 xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
612 $BOOK/chapter03/chapter03.xml >>$LOGDIR/$LOG 2>&1
613 ;;
614 esac
[4965fa8]615
616 if [[ "${BLFS_TOOL}" = "y" ]] ; then
617(
618cat << EOF
619$LIBXML_PKG
620$LIBXSLT_PKG
621$DBXSL_PKG
622$LINKS_PKG
623$SUDO_PKG
624$WGET_PKG
625$SVN_PKG
626$GPM_PKG
627EOF
628) >> pkg_tarball_list
629 fi
630
[dd29d02]631 echo " ...OK"
632
633}
634
635
[877cc6a]636#----------------------------#
[15cad16]637get_sources() { # Download file, write name to MISSING_FILES.DMP if an error
[93135fd]638#----------------------------#
639 local saveIFS=$IFS
[26053c4]640 local IFS line URL1 URL2 FILE BOOKMD5 MD5 HAVEMD5 fromARCHIVE
[93135fd]641
642 # Test if the packages must be downloaded
[401f81e]643 [ ! "$GETPKG" = "y" ] && return
[93135fd]644
645 gs_wrt_message(){
646 echo "${RED}$1${OFF}"
[c7dbe78]647 echo "$1" >> MISSING_FILES.DMP
648 }
[93135fd]649 # Housekeeping
650 [[ ! -d $BUILDDIR/sources ]] && mkdir $BUILDDIR/sources
651 cd $BUILDDIR/sources
652 [[ -f MD5SUMS ]] && rm MD5SUMS
653 [[ -f MISSING_FILES.DMP ]] && rm MISSING_FILES.DMP
654 [[ -f urls.lst ]] && rm urls.lst
655
656 # Generate URLs file
657 create_urls
658
659 IFS=$'\x0A' # Modify the 'internal field separator' to break on 'LF' only
660 for line in `cat urls.lst`; do
661 IFS=$saveIFS # Restore the system defaults
662
663 # Skip some packages if they aren't needed
664 case $line in
665 */tcl* | */expect* | */dejagnu* | */tree* | */gcc-testsuite* )
666 [[ "$TEST" = "0" ]] && continue
667 ;;
668 */vim-*-lang* )
669 [[ "$VIMLANG" = "0" ]] && continue
670 ;;
[0c3f2f9]671 *linux/linux-* )
[294c937]672 [[ -z "$CONFIG" ]] && [[ -z "$BOOT_CONFIG" ]] && \
[401f81e]673 [[ "$GETKERNEL" = "n" ]] && continue
[0c3f2f9]674 ;;
[93135fd]675 esac
676
677 # Locations
[296ae69]678 URL1=`echo $line | cut -d" " -f2` # Preferred URL
679 URL2=`echo $line | cut -d" " -f1` # Fallback Upstream URL
[26053c4]680 FILE=`basename $URL1` # File name
681 BOOKMD5=`echo $line | cut -d" " -f3` # MD5 book value
682
[8a43b5b]683 # Validation pair
684 MD5="$BOOKMD5 $FILE"
685 HAVEMD5=1
[93135fd]686
687 set -e
[c7dbe78]688 # If the file exists in the archive copy it to the
[93135fd]689 # $BUILDDIR/sources dir. MD5SUM will be validated later.
690 if [ ! -z ${SRC_ARCHIVE} ] &&
691 [ -d ${SRC_ARCHIVE} ] &&
692 [ -f ${SRC_ARCHIVE}/$FILE ]; then
693 cp ${SRC_ARCHIVE}/$FILE .
694 echo "$FILE: -- copied from $SRC_ARCHIVE"
695 fromARCHIVE=1
696 else
697 echo "${BOLD}${YELLOW}$FILE: not found in ${SRC_ARCHIVE}${OFF}"
698 fromARCHIVE=0
[8a43b5b]699 # If the file does not exist yet in /sources download a fresh one
[93135fd]700 if [ ! -f $FILE ] ; then
701 if ! wget $URL1 && ! wget $URL2 ; then
[c7dbe78]702 gs_wrt_message "$FILE not found in the SRC_ARCHIVE or on any server..SKIPPING"
703 continue
[93135fd]704 fi
705 fi
706 fi
707
[8a43b5b]708 # IF the md5sum does not match the existing files
709 if ! echo "$MD5" | md5sum -c - >/dev/null ; then
710 [[ $fromARCHIVE = "1" ]] && echo "${BOLD}${YELLOW}MD5SUM did not match SRC_ARCHIVE copy${OFF}"
711 [[ $fromARCHIVE = "0" ]] && echo "${BOLD}${YELLOW}MD5SUM did not match REMOTE copy${OFF}"
712 # Remove the old file and download a new one
713 rm -fv $FILE
714 # Force storage in SRC_ARCHIVE
715 fromARCHIVE=0;
716 # Try to retrieve again the file. Servers in reverse order.
717 if ! wget $URL2 && ! wget $URL1 ; then
718 gs_wrt_message "$FILE not found on the servers.. SKIPPING"
719 continue
[93135fd]720 fi
721 fi
722
723 # Validate the MD5SUM one last time
[8a43b5b]724 if ! echo "$MD5" | md5sum -c - >/dev/null ; then
[93135fd]725 gs_wrt_message "$FILE does not match MD5SUMS value"
[0910f55]726 # Force generation of MD5SUM
727 HAVEMD5=0
[93135fd]728 fi
729
730 # Generate a fresh MD5SUM for this file
731 if [[ "$HAVEMD5" = "0" ]] ; then
732 echo "${BOLD}${YELLOW}Generating a new MD5SUM for ${OFF}$FILE"
[8a43b5b]733 echo "NEW MD5SUM: $(md5sum $FILE)" >> MISSING_FILES.DMP
[93135fd]734 fi
735
736 # Good or bad we write the original md5sum to a file
[8a43b5b]737 echo "$MD5" >> MD5SUMS
[93135fd]738
739 # Copy the freshly downloaded file
740 # to the source archive.
741 if [ ! -z ${SRC_ARCHIVE} ] &&
742 [ -d ${SRC_ARCHIVE} ] &&
743 [ -w ${SRC_ARCHIVE} ] &&
744 [ "$fromARCHIVE" = "0" ] ; then
745 echo "Storing file:<$FILE> in the package archive"
746 cp -f $FILE ${SRC_ARCHIVE}
747 fi
748
749 done
750
751 if [[ -s MISSING_FILES.DMP ]]; then
[d385453]752 echo -e "\n\n${tab_}${RED} One or more files were not retrieved or have bad MD5SUMS.\n${tab_} Check ${L_arrow}$BUILDDIR/sources/MISSING_FILES.DMP${R_arrow} for names ${OFF}\n"
753 # Do not allow the automatic execution of the Makefile.
[261eea6]754 echo "${tab_}${BOLD}${RED}*** ${YELLOW}Automatic execution of the generated makefile has been inhibited. ${RED}***${OFF}${nl_}"
[401f81e]755 RUNMAKE="n"
[93135fd]756 fi
757}
758
[877cc6a]759#----------------------------#
[15cad16]760create_urls() { #
[877cc6a]761#----------------------------#
[15cad16]762 cd $JHALFSDIR
[877cc6a]763
[15cad16]764 case ${PROGNAME} in
765 clfs)
766 echo -n "Creating CLFS <${ARCH}> specific URLs file"
767 xsltproc --nonet --xinclude \
768 --stringparam server $SERVER \
769 -o $BUILDDIR/sources/urls.lst urls.xsl \
770 $BOOK/materials/$ARCH-chapter.xml >>$LOGDIR/$LOG 2>&1
771 echo " ...OK"
772 ;;
[7432834]773 clfs2)
774 echo -n "Creating CLFS2 <${ARCH}> specific URLs file"
775 xsltproc --nonet --xinclude \
776 --stringparam server $SERVER \
777 -o $BUILDDIR/sources/urls.lst urls.xsl \
778 $BOOK/materials/$ARCH-chapter.xml >>$LOGDIR/$LOG 2>&1
779 echo " ...OK"
780 ;;
[15cad16]781 hlfs)
782 echo -n "Creating HLFS <${MODEL}> specific URLs file"
783 xsltproc --nonet --xinclude \
784 --stringparam server $SERVER \
785 --stringparam model $MODEL \
786 -o $BUILDDIR/sources/urls.lst urls.xsl \
787 $BOOK/chapter04/chapter04.xml >>$LOGDIR/$LOG 2>&1
788 echo " ...OK"
789 ;;
790 lfs)
791 echo -n "Creating LFS specific URLs file"
792 xsltproc --nonet --xinclude \
793 --stringparam server $SERVER \
794 -o ../sources/urls.lst urls.xsl \
795 $BOOK/chapter03/chapter03.xml >>$LOGDIR/$LOG 2>&1
796 echo " ...OK"
797 ;;
798 esac
[877cc6a]799
[15cad16]800 cd $BUILDDIR/sources
[4965fa8]801
[05d1b17]802 if [[ "${BLFS_TOOL}" = "y" ]]; then
803 add_blfs_deps_urls
804 fi
[4965fa8]805}
806
807#----------------------------# Hardcoded URLs and MD5.
808add_blfs_deps_urls() { # No easy way to extract it.
809#----------------------------# Some FTP mirrors may not work
810
811 local BLFS_SERVER="${SERVER}/pub/blfs/conglomeration/"
812
813 if [[ "${DEP_LIBXML}" = "y" ]] ; then
814 echo "${LIBXML_URL} ${BLFS_SERVER}libxml2/${LIBXML_PKG} ${LIBXML_MD5}" >> urls.lst
815 fi
816
817 if [[ "${DEP_LIBXSLT}" = "y" ]] ; then
818 echo "${LIBXSLT_URL} ${BLFS_SERVER}libxslt/${LIBXSLT_PKG} ${LIBXSLT_MD5}" >> urls.lst
819 fi
820
821 if [[ "${DEP_DBXSL}" = "y" ]] ; then
822 echo "${DBXSL_URL} ${BLFS_SERVER}docbook-xsl/${DBXSL_PKG} ${DBXSL_MD5}" >> urls.lst
823 fi
824
825 if [[ "${DEP_LINKS}" = "y" ]] ; then
826 echo "${LINKS_URL} ${BLFS_SERVER}links/${LINKS_PKG} ${LINKS_MD5}" >> urls.lst
827 fi
828
829 if [[ "${DEP_SUDO}" = "y" ]] ; then
830 echo "${SUDO_URL} ${BLFS_SERVER}sudo/${SUDO_PKG} ${SUDO_MD5}" >> urls.lst
831 echo "${SUDO_PATCH_URL} ${BLFS_SERVER}sudo/${SUDO_PATCH} ${SUDO_PATCH_MD5}" >> urls.lst
832 fi
833
834 if [[ "${DEP_WGET}" = "y" ]] ; then
835 echo "${WGET_URL} ${BLFS_SERVER}wget/${WGET_PKG} ${WGET_MD5}" >> urls.lst
836 fi
837
838 if [[ "${DEP_SVN}" = "y" ]] ; then
839 echo "${SVN_URL} ${BLFS_SERVER}subversion/${SVN_PKG} ${SVN_MD5}" >> urls.lst
840 fi
841
842 if [[ "${DEP_GPM}" = "y" ]] ; then
843 echo "${GPM_URL} ${BLFS_SERVER}gpm/${GPM_PKG} ${GPM_MD5}" >> urls.lst
844 echo "${GPM_PATCH_1_URL} ${BLFS_SERVER}gpm/${GPM_PATCH_1} ${GPM_PATCH_1_MD5}" >> urls.lst
845 echo "${GPM_PATCH_2_URL} ${BLFS_SERVER}gpm/${GPM_PATCH_2} ${GPM_PATCH_2_MD5}" >> urls.lst
846 fi
847
848}
849
850#----------------------------# Maybe there is a better way to do this, but this
851copy_blfs_deps_scripts() { # method avoid to place the test on all
852#----------------------------# $PROGNAME/master.sh scripts.
853
854 mkdir -p ${PROGNAME}-commands/blfs-tool-deps
855
856 if [[ "${DEP_LIBXML}" = "y" ]] ; then
857 mv blfs-tool-deps/901-libxml2 ${PROGNAME}-commands/blfs-tool-deps
858 fi
859
860 if [[ "${DEP_LIBXSLT}" = "y" ]] ; then
861 mv blfs-tool-deps/902-libxslt ${PROGNAME}-commands/blfs-tool-deps
862 fi
863
864 if [[ "${DEP_DBXSL}" = "y" ]] ; then
865 mv blfs-tool-deps/903-docbook-xsl ${PROGNAME}-commands/blfs-tool-deps
866 fi
867
868 if [[ "${DEP_LINKS}" = "y" ]] ; then
869 mv blfs-tool-deps/905-links ${PROGNAME}-commands/blfs-tool-deps
870 fi
871
872 if [[ "${DEP_SUDO}" = "y" ]] ; then
873 mv blfs-tool-deps/906-sudo ${PROGNAME}-commands/blfs-tool-deps
874 fi
875
876 if [[ "${DEP_WGET}" = "y" ]] ; then
877 mv blfs-tool-deps/907-wget ${PROGNAME}-commands/blfs-tool-deps
878 fi
879
880 if [[ "${DEP_SVN}" = "y" ]] ; then
881 mv blfs-tool-deps/908-subversion ${PROGNAME}-commands/blfs-tool-deps
882 fi
883
884 if [[ "${DEP_GPM}" = "y" ]] ; then
885 mv blfs-tool-deps/904-gpm ${PROGNAME}-commands/blfs-tool-deps
886 fi
887
888 rm -rf blfs-tool-deps
889
[877cc6a]890}
Note: See TracBrowser for help on using the repository browser.